diff --git a/src/vbox/vbox_tmpl.c b/src/vbox/vbox_tmpl.c
index 3208f03..0e829e3 100644
--- a/src/vbox/vbox_tmpl.c
+++ b/src/vbox/vbox_tmpl.c
@@ -3872,12 +4537,461 @@ static int vboxDomainDetachDevice(virDomainPtr dom, const char *xml) {
     }
 
 cleanup:
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     virDomainDefFree(def);
     virDomainDeviceDefFree(dev);
     return ret;
 }
 
+#if VBOX_API_VERSION == 2002
+    /* No Callback support for VirtualBox 2.2.* series */
+#else /* !(VBOX_API_VERSION == 2002) */
+
+/* Functions needed for Callbacks */
+static  nsresult vboxCallbackOnMachineStateChange (IVirtualBoxCallback *pThis,
+                                                   PRUnichar * machineId,
+                                                   PRUint32 state) {
+    virDomainPtr dom = NULL;
+    int event        = 0;
+    int detail       = 0;
+
+    g_pVBoxGlobalData->domainEventDispatching = 1;
+    vboxDriverLock(g_pVBoxGlobalData);
+
+    DEBUG("IVirtualBoxCallback: %p, State: %d", pThis, state);
+    DEBUGPRUnichar(machineId);
+
+    if (machineId) {
+        char *machineIdUtf8       = NULL;
+        unsigned char uuid[VIR_UUID_BUFLEN];
+
+        g_pVBoxGlobalData->pFuncs->pfnUtf16ToUtf8(machineId, &machineIdUtf8);
+        virUUIDParse(machineIdUtf8, uuid);
+
+        dom = vboxDomainLookupByUUID(g_pVBoxGlobalData->conn, uuid);
+        if (dom) {
+            int i = 0;
+
+            if (state == MachineState_Starting) {
+                event  = VIR_DOMAIN_EVENT_STARTED;
+                detail = VIR_DOMAIN_EVENT_STARTED_BOOTED;
+            } else if (state == MachineState_Restoring) {
+                event  = VIR_DOMAIN_EVENT_STARTED;
+                detail = VIR_DOMAIN_EVENT_STARTED_RESTORED;
+            } else if (state == MachineState_Paused) {
+                event  = VIR_DOMAIN_EVENT_SUSPENDED;
+                detail = VIR_DOMAIN_EVENT_SUSPENDED_PAUSED;
+            } else if (state == MachineState_Running) {
+                event  = VIR_DOMAIN_EVENT_RESUMED;
+                detail = VIR_DOMAIN_EVENT_RESUMED_UNPAUSED;
+            } else if (state == MachineState_PoweredOff) {
+                event  = VIR_DOMAIN_EVENT_STOPPED;
+                detail = VIR_DOMAIN_EVENT_STOPPED_SHUTDOWN;
+            } else if (state == MachineState_Stopping) {
+                event  = VIR_DOMAIN_EVENT_STOPPED;
+                detail = VIR_DOMAIN_EVENT_STOPPED_DESTROYED;
+            } else if (state == MachineState_Aborted) {
+                event  = VIR_DOMAIN_EVENT_STOPPED;
+                detail = VIR_DOMAIN_EVENT_STOPPED_CRASHED;
+            } else if (state == MachineState_Saving) {
+                event  = VIR_DOMAIN_EVENT_STOPPED;
+                detail = VIR_DOMAIN_EVENT_STOPPED_SAVED;
+            } else {
+                event  = VIR_DOMAIN_EVENT_STOPPED;
+                detail = VIR_DOMAIN_EVENT_STOPPED_SHUTDOWN;
+            }
+
+            for (i = 0; i < g_pVBoxGlobalData->domainEventCallbacks->count; i++) {
+                if (g_pVBoxGlobalData->domainEventCallbacks->callbacks[i]->cb) {
+                    g_pVBoxGlobalData->domainEventCallbacks->callbacks[i]->cb(g_pVBoxGlobalData->conn,
+                                                                              dom,
+                                                                              event,
+                                                                              detail,
+                                                                              NULL);
+                }
+            }
+        }
+    }
+
+    virDomainEventCallbackListPurgeMarked(g_pVBoxGlobalData->domainEventCallbacks);
+
+    vboxDriverUnlock(g_pVBoxGlobalData);
+    g_pVBoxGlobalData->domainEventDispatching = 1;
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackOnMachineDataChange (IVirtualBoxCallback *pThis,
+                                                 PRUnichar * machineId) {
+    DEBUG("IVirtualBoxCallback: %p", pThis);
+    DEBUGPRUnichar(machineId);
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackOnExtraDataCanChange (IVirtualBoxCallback *pThis,
+                                                  PRUnichar * machineId,
+                                                  PRUnichar * key,
+                                                  PRUnichar * value,
+                                                  PRUnichar * * error,
+                                                  PRBool * allowChange) {
+    DEBUG("IVirtualBoxCallback: %p, allowChange: %s", pThis, *allowChange ? "true" : "false");
+    DEBUGPRUnichar(machineId);
+    DEBUGPRUnichar(key);
+    DEBUGPRUnichar(value);
+    (void)error; /* so that the compiler doesn't complain about unsed variables */
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackOnExtraDataChange (IVirtualBoxCallback *pThis,
+                                               PRUnichar * machineId,
+                                               PRUnichar * key,
+                                               PRUnichar * value) {
+    DEBUG("IVirtualBoxCallback: %p", pThis);
+    DEBUGPRUnichar(machineId);
+    DEBUGPRUnichar(key);
+    DEBUGPRUnichar(value);
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackOnMediaRegistered (IVirtualBoxCallback *pThis,
+                                               PRUnichar * mediaId,
+                                               PRUint32 mediaType,
+                                               PRBool registered) {
+    DEBUG("IVirtualBoxCallback: %p, registered: %s", pThis, registered ? "true" : "false");
+    DEBUG("mediaType: %d", mediaType);
+    DEBUGPRUnichar(mediaId);
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackOnMachineRegistered (IVirtualBoxCallback *pThis,
+                                                 PRUnichar * machineId,
+                                                 PRBool registered) {
+    virDomainPtr dom = NULL;
+    int event        = 0;
+    int detail       = 0;
+
+    g_pVBoxGlobalData->domainEventDispatching = 1;
+    vboxDriverLock(g_pVBoxGlobalData);
+
+    DEBUG("IVirtualBoxCallback: %p, registered: %s", pThis, registered ? "true" : "false");
+    DEBUGPRUnichar(machineId);
+
+    if (machineId) {
+        char *machineIdUtf8       = NULL;
+        unsigned char uuid[VIR_UUID_BUFLEN];
+
+        g_pVBoxGlobalData->pFuncs->pfnUtf16ToUtf8(machineId, &machineIdUtf8);
+        virUUIDParse(machineIdUtf8, uuid);
+
+        dom = vboxDomainLookupByUUID(g_pVBoxGlobalData->conn, uuid);
+        if (dom) {
+            int i = 0;
+
+            /* CURRENT LIMITATION: we never get the VIR_DOMAIN_EVENT_UNDEFINED
+             * event becuase the when the machine is de-registered the call
+             * to vboxDomainLookupByUUID fails and thus we don't get any
+             * dom pointer which is necessary (null dom pointer doesn't work)
+             * to show the VIR_DOMAIN_EVENT_UNDEFINED event
+             */
+            if (registered) {
+                event  = VIR_DOMAIN_EVENT_DEFINED;
+                detail = VIR_DOMAIN_EVENT_DEFINED_ADDED;
+            } else {
+                event  = VIR_DOMAIN_EVENT_UNDEFINED;
+                detail = VIR_DOMAIN_EVENT_UNDEFINED_REMOVED;
+            }
+
+            for (i = 0; i < g_pVBoxGlobalData->domainEventCallbacks->count; i++) {
+                if (g_pVBoxGlobalData->domainEventCallbacks->callbacks[i]->cb) {
+                    g_pVBoxGlobalData->domainEventCallbacks->callbacks[i]->cb(g_pVBoxGlobalData->conn,
+                                                                              dom,
+                                                                              event,
+                                                                              detail,
+                                                                              NULL);
+                }
+            }
+        }
+    }
+
+    virDomainEventCallbackListPurgeMarked(g_pVBoxGlobalData->domainEventCallbacks);
+
+    vboxDriverUnlock(g_pVBoxGlobalData);
+    g_pVBoxGlobalData->domainEventDispatching = 1;
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackOnSessionStateChange (IVirtualBoxCallback *pThis,
+                                                  PRUnichar * machineId,
+                                                  PRUint32 state) {
+    DEBUG("IVirtualBoxCallback: %p, state: %d", pThis, state);
+    DEBUGPRUnichar(machineId);
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackOnSnapshotTaken (IVirtualBoxCallback *pThis,
+                                             PRUnichar * machineId,
+                                             PRUnichar * snapshotId) {
+    DEBUG("IVirtualBoxCallback: %p", pThis);
+    DEBUGPRUnichar(machineId);
+    DEBUGPRUnichar(snapshotId);
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackOnSnapshotDiscarded (IVirtualBoxCallback *pThis,
+                                                 PRUnichar * machineId,
+                                                 PRUnichar * snapshotId) {
+    DEBUG("IVirtualBoxCallback: %p", pThis);
+    DEBUGPRUnichar(machineId);
+    DEBUGPRUnichar(snapshotId);
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackOnSnapshotChange (IVirtualBoxCallback *pThis,
+                                              PRUnichar * machineId,
+                                              PRUnichar * snapshotId) {
+    DEBUG("IVirtualBoxCallback: %p", pThis);
+    DEBUGPRUnichar(machineId);
+    DEBUGPRUnichar(snapshotId);
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackOnGuestPropertyChange (IVirtualBoxCallback *pThis,
+                                                   PRUnichar * machineId,
+                                                   PRUnichar * name,
+                                                   PRUnichar * value,
+                                                   PRUnichar * flags) {
+    DEBUG("IVirtualBoxCallback: %p", pThis);
+    DEBUGPRUnichar(machineId);
+    DEBUGPRUnichar(name);
+    DEBUGPRUnichar(value);
+    DEBUGPRUnichar(flags);
+
+    return NS_OK;
+}
+
+static nsresult vboxCallbackAddRef(nsISupports *pThis) {
+    nsresult c;
+
+    c = ++g_pVBoxGlobalData->vboxCallBackRefCount;
+
+    DEBUG("pThis: %p, vboxCallback AddRef: %d", pThis, c);
+
+    return c;
+}
+
+static nsresult vboxCallbackRelease(nsISupports *pThis) {
+    nsresult c;
+
+    c = --g_pVBoxGlobalData->vboxCallBackRefCount;
+    if (c == 0) {
+        /* delete object */
+        VIR_FREE(pThis->vtbl);
+        VIR_FREE(pThis);
+    }
+
+    DEBUG("pThis: %p, vboxCallback Release: %d", pThis, c);
+
+    return c;
+}
+
+static nsresult vboxCallbackQueryInterface(nsISupports *pThis, const nsID *iid, void **resultp) {
+    IVirtualBoxCallback *that = (IVirtualBoxCallback *)pThis;
+    static const nsID ivirtualboxCallbackUUID = IVIRTUALBOXCALLBACK_IID;
+    static const nsID isupportIID = NS_ISUPPORTS_IID;
+
+    /* Match UUID for IVirtualBoxCallback class */
+    if (    memcmp(iid, &ivirtualboxCallbackUUID, sizeof(nsID)) == 0
+        ||  memcmp(iid, &isupportIID, sizeof(nsID)) == 0) {
+        g_pVBoxGlobalData->vboxCallBackRefCount++;
+        *resultp = that;
+
+        DEBUG("pThis: %p, vboxCallback QueryInterface: %d", pThis, g_pVBoxGlobalData->vboxCallBackRefCount);
+
+        return NS_OK;
+    }
+
+
+    DEBUG("pThis: %p, vboxCallback QueryInterface didn't find a matching interface", pThis);
+    DEBUGUUID(iid);
+    DEBUGUUID(&ivirtualboxCallbackUUID);
+    return NS_NOINTERFACE;
+}
+
+
+static IVirtualBoxCallback *vboxAllocCallbackObj (virConnectPtr conn) {
+    IVirtualBoxCallback *vboxCallback = NULL;
+
+    /* Allocate, Initialize and return a validi
+     * IVirtualBoxCallback object here
+     */
+    if ((VIR_ALLOC(vboxCallback) < 0) || (VIR_ALLOC(vboxCallback->vtbl) < 0)) {
+        virReportOOMError(conn);
+        return NULL;
+    }
+
+    {
+        vboxCallback->vtbl->nsisupports.AddRef          = &vboxCallbackAddRef;
+        vboxCallback->vtbl->nsisupports.Release         = &vboxCallbackRelease;
+        vboxCallback->vtbl->nsisupports.QueryInterface  = &vboxCallbackQueryInterface;
+        vboxCallback->vtbl->OnMachineStateChange        = &vboxCallbackOnMachineStateChange;
+        vboxCallback->vtbl->OnMachineDataChange         = &vboxCallbackOnMachineDataChange;
+        vboxCallback->vtbl->OnExtraDataCanChange        = &vboxCallbackOnExtraDataCanChange;
+        vboxCallback->vtbl->OnExtraDataChange           = &vboxCallbackOnExtraDataChange;
+        vboxCallback->vtbl->OnMediaRegistered           = &vboxCallbackOnMediaRegistered;
+        vboxCallback->vtbl->OnMachineRegistered         = &vboxCallbackOnMachineRegistered;
+        vboxCallback->vtbl->OnSessionStateChange        = &vboxCallbackOnSessionStateChange;
+        vboxCallback->vtbl->OnSnapshotTaken             = &vboxCallbackOnSnapshotTaken;
+        vboxCallback->vtbl->OnSnapshotDiscarded         = &vboxCallbackOnSnapshotDiscarded;
+        vboxCallback->vtbl->OnSnapshotChange            = &vboxCallbackOnSnapshotChange;
+        vboxCallback->vtbl->OnGuestPropertyChange       = &vboxCallbackOnGuestPropertyChange;
+        g_pVBoxGlobalData->vboxCallBackRefCount = 1;
+
+    }
+
+    return vboxCallback;
+}
+
+static void vboxReadCallback(int watch ATTRIBUTE_UNUSED,
+                             int fd,
+                             int events ATTRIBUTE_UNUSED,
+                             void *opaque ATTRIBUTE_UNUSED) {
+    if (fd >= 0) {
+        g_pVBoxGlobalData->vboxQueue->vtbl->ProcessPendingEvents(g_pVBoxGlobalData->vboxQueue);
+    } else {
+        nsresult rc;
+        PLEvent *pEvent = NULL;
+
+        rc = g_pVBoxGlobalData->vboxQueue->vtbl->WaitForEvent(g_pVBoxGlobalData->vboxQueue, &pEvent);
+        if (NS_SUCCEEDED(rc))
+            g_pVBoxGlobalData->vboxQueue->vtbl->HandleEvent(g_pVBoxGlobalData->vboxQueue, pEvent);
+    }
+}
+
+static int vboxDomainEventRegister (virConnectPtr conn,
+                                    virConnectDomainEventCallback callback,
+                                    void *opaque,
+                                    virFreeCallback freecb) {
+    nsresult rc;
+    vboxGlobalData *data = conn->privateData;
+    int vboxRet          = -1;
+    int eventRet         = -1;
+    int ret              = -1;
+
+    /* Locking has to be there as callbacks are not
+     * really fully thread safe
+     */
+    vboxDriverLock(data);
+
+    if(data->vboxObj) {
+        if (data->vboxCallback == NULL) {
+            data->vboxCallback = vboxAllocCallbackObj(conn);
+            if (data->vboxCallback != NULL) {
+                rc = data->vboxObj->vtbl->RegisterCallback(data->vboxObj, data->vboxCallback);
+                if (NS_SUCCEEDED(rc)) {
+                    vboxRet = 0;
+                }
+            }
+        } else {
+            vboxRet = 0;
+        }
+
+        /* Get the vbox file handle and add a event handle to it
+         * so that the events can be passed down to the user
+         */
+        if (vboxRet == 0) {
+            PRInt32 vboxFileHandle;
+            vboxFileHandle = g_pVBoxGlobalData->vboxQueue->vtbl->GetEventQueueSelectFD(g_pVBoxGlobalData->vboxQueue);
+
+            eventRet = virEventAddHandle(vboxFileHandle, VIR_EVENT_HANDLE_READABLE, vboxReadCallback, NULL, NULL);
+
+            if (eventRet >= 0) {
+                /* Once a callback is registered with virtualbox, use a list
+                 * to store the callbacks registered with libvirt so that
+                 * later you can iterate over them
+                 */
+
+                ret = virDomainEventCallbackListAdd(conn, data->domainEventCallbacks,
+                                                    callback, opaque, freecb);
+                DEBUG("virDomainEventCallbackListAdd (ret = %d) ( conn: %p, "
+                      "data->domainEventCallbacks: %p, callback: %p, opaque: %p, "
+                      "freecb: %p )", ret, conn, data->domainEventCallbacks, callback,
+                      opaque, freecb);
+            }
+        }
+    }
+
+    vboxDriverUnlock(data);
+
+    if (ret >= 0) {
+        return ret;
+    } else {
+        if (data->vboxObj && data->vboxCallback) {
+            data->vboxObj->vtbl->UnregisterCallback(data->vboxObj, data->vboxCallback);
+        }
+        return -1;
+    }
+}
+
+static int vboxDomainEventDeregister (virConnectPtr conn,
+                                      virConnectDomainEventCallback callback) {
+    vboxGlobalData *data = conn->privateData;
+    int ret              = -1;
+
+    /* Locking has to be there as callbacks are not
+     * really fully thread safe
+     */
+    vboxDriverLock(data);
+
+    if (data->domainEventDispatching)
+        ret = virDomainEventCallbackListMarkDelete(conn, data->domainEventCallbacks,
+                                                   callback);
+    else
+        ret = virDomainEventCallbackListRemove(conn, data->domainEventCallbacks,
+                                               callback);
+
+    virEventRemoveHandle(0);
+
+    if(data->vboxObj && data->vboxCallback) {
+        /* check count here of how many times register was called
+         * and only on the last de-register do the un-register call
+         */
+        if (data->domainEventCallbacks && (data->domainEventCallbacks->count <= 0)) {
+            int i = 0;
+
+            data->vboxObj->vtbl->UnregisterCallback(data->vboxObj, data->vboxCallback);
+            data->vboxCallback->vtbl->nsisupports.Release((nsISupports *)data->vboxCallback);
+
+            /* iterate and free all the opaque objects using the
+             * freecb callback provided in vboxDomainEventRegister()
+             */
+            for (i = 0; i < data->domainEventCallbacks->count; i++) {
+                if (data->domainEventCallbacks->callbacks[i]->freecb) {
+                    data->domainEventCallbacks->callbacks[i]->freecb(data->domainEventCallbacks->callbacks[i]->opaque);
+                }
+            }
+        }
+    }
+
+    vboxDriverUnlock(data);
+
+    return ret;
+}
+
+#endif /* !(VBOX_API_VERSION == 2002) */
+
 /**
  * The Network Functions here on
  */
@@ -4117,13 +5231,25 @@ static int vboxListDefinedNetworks(virConnectPtr conn, char **const names, int n
 static virNetworkPtr vboxNetworkLookupByUUID(virConnectPtr conn, const unsigned char *uuid) {
     vboxGlobalData *data = conn->privateData;
     virNetworkPtr ret    = NULL;
+#if VBOX_API_VERSION == 2002
     nsID *iid            = NULL;
 
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(conn);
         goto cleanup;
     }
+    nsIDFromChar(iid, uuid);
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+
+    virUUIDFormat(uuid, iidUtf8);
+    data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+#endif
 
+    /* TODO: "internal" networks are just strings and
+     * thus can't do much with them
+     */
     if (data->vboxObj) {
         IHost *host = NULL;
 
@@ -4131,8 +5257,11 @@ static virNetworkPtr vboxNetworkLookupByUUID(virConnectPtr conn, const unsigned
         if (host) {
             IHostNetworkInterface *networkInterface = NULL;
 
-            nsIDFromChar(iid, uuid);
+#if VBOX_API_VERSION == 2002
             host->vtbl->FindHostNetworkInterfaceById(host, iid, &networkInterface);
+#else
+            host->vtbl->FindHostNetworkInterfaceById(host, iidUtf16, &networkInterface);
+#endif
             if (networkInterface) {
                 PRUint32 interfaceType = 0;
 
@@ -4148,6 +5277,7 @@ static virNetworkPtr vboxNetworkLookupByUUID(virConnectPtr conn, const unsigned
                     ret = virGetNetwork(conn, nameUtf8, uuid);
 
                     DEBUG("Network Name: %s", nameUtf8);
+#if VBOX_API_VERSION == 2002
                     DEBUG("Network UUID: "
                           "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
                           (unsigned)iid->m0,    (unsigned)iid->m1,
@@ -4156,6 +5286,9 @@ static virNetworkPtr vboxNetworkLookupByUUID(virConnectPtr conn, const unsigned
                           (unsigned)iid->m3[3], (unsigned)iid->m3[4],
                           (unsigned)iid->m3[5], (unsigned)iid->m3[6],
                           (unsigned)iid->m3[7]);
+#else
+                    DEBUG("Network UUID: %s", iidUtf8);
+#endif
 
                     data->pFuncs->pfnUtf8Free(nameUtf8);
                     data->pFuncs->pfnUtf16Free(nameUtf16);
@@ -4168,8 +5301,12 @@ static virNetworkPtr vboxNetworkLookupByUUID(virConnectPtr conn, const unsigned
         }
     }
 
+#if VBOX_API_VERSION == 2002
 cleanup:
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     return ret;
 }
 
@@ -4196,12 +5333,11 @@ static virNetworkPtr vboxNetworkLookupByName(virConnectPtr conn, const char *nam
 
                 if (interfaceType == HostNetworkInterfaceType_HostOnly) {
                     unsigned char uuid[VIR_UUID_BUFLEN];
+#if VBOX_API_VERSION == 2002
                     nsID *iid = NULL;
 
                     networkInterface->vtbl->GetId(networkInterface, &iid);
-
                     nsIDtoChar(uuid, iid);
-
                     ret = virGetNetwork(conn, name, uuid);
 
                     DEBUG("Network Name: %s", name);
@@ -4215,6 +5351,21 @@ static virNetworkPtr vboxNetworkLookupByName(virConnectPtr conn, const char *nam
                           (unsigned)iid->m3[7]);
 
                     data->pFuncs->pfnComUnallocMem(iid);
+#else
+                    PRUnichar *iidUtf16 = NULL;
+                    char      *iidUtf8  = NULL;;
+
+                    networkInterface->vtbl->GetId(networkInterface, &iidUtf16);
+                    data->pFuncs->pfnUtf16ToUtf8(iidUtf16, &iidUtf8);
+                    virUUIDParse(iidUtf8, uuid);
+                    ret = virGetNetwork(conn, name, uuid);
+
+                    DEBUG("Network Name: %s", name);
+                    DEBUG("Network UUID: %s", iidUtf8);
+
+                    data->pFuncs->pfnUtf8Free(iidUtf8);
+                    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
                 }
 
                 networkInterface->vtbl->nsisupports.Release((nsISupports *) networkInterface);
@@ -4232,18 +5383,23 @@ static virNetworkPtr vboxNetworkCreateXML(virConnectPtr conn, const char *xml) {
     vboxGlobalData *data  = conn->privateData;
     virNetworkDefPtr def  = NULL;
     virNetworkPtr ret     = NULL;
-    nsID *iid             = NULL;
+#if VBOX_API_VERSION == 2002
+    nsID  *iid           = NULL;
+#else
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     char *networkNameUtf8 = NULL;
 
     if ((def = virNetworkDefParseString(conn, xml)) == NULL)
         goto cleanup;
 
-    if (VIR_ALLOC(iid) < 0) {
+    if (virAsprintf(&networkNameUtf8, "HostInterfaceNetworking-%s", def->name) < 0) {
         virReportOOMError(conn);
         goto cleanup;
     }
 
-    if (virAsprintf(&networkNameUtf8, "HostInterfaceNetworking-%s", def->name) < 0) {
+#if VBOX_API_VERSION == 2002
+    if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(conn);
         goto cleanup;
     }
@@ -4259,6 +5415,10 @@ static virNetworkPtr vboxNetworkCreateXML(virConnectPtr conn, const char *xml) {
           (unsigned)iid->m3[3], (unsigned)iid->m3[4],
           (unsigned)iid->m3[5], (unsigned)iid->m3[6],
           (unsigned)iid->m3[7]);
+#else
+    virUUIDFormat(def->uuid, iidUtf8);
+    DEBUG("Network UUID: %s", iidUtf8);
+#endif
 
     if ((data->vboxObj) && (def->forwardType == VIR_NETWORK_FORWARD_NONE)) {
         /* VirtualBox version 2.2.* has only one "hostonly"
@@ -4283,14 +5443,22 @@ static virNetworkPtr vboxNetworkCreateXML(virConnectPtr conn, const char *xml) {
 
                     if (interfaceType == HostNetworkInterfaceType_HostOnly) {
                         unsigned char uuid[VIR_UUID_BUFLEN];
-                        nsID *vboxnet0IID           = NULL;
                         PRUnichar *networkNameUtf16 = NULL;
-
-                        data->pFuncs->pfnUtf8ToUtf16(networkNameUtf8 , &networkNameUtf16);
+#if VBOX_API_VERSION == 2002
+                        nsID *vboxnet0IID           = NULL;
 
                         networkInterface->vtbl->GetId(networkInterface, &vboxnet0IID);
-
                         nsIDtoChar(uuid, vboxnet0IID);
+#else
+                        PRUnichar *vboxnet0IIDUtf16 = NULL;
+                        char      *vboxnet0IIDUtf8  = NULL;
+
+                        networkInterface->vtbl->GetId(networkInterface, &vboxnet0IIDUtf16);
+                        data->pFuncs->pfnUtf16ToUtf8(vboxnet0IIDUtf16, &vboxnet0IIDUtf8);
+                        virUUIDParse(vboxnet0IIDUtf8, uuid);
+#endif
+                        data->pFuncs->pfnUtf8ToUtf16(networkNameUtf8 , &networkNameUtf16);
+
 
                         /* Currently support only one dhcp server per network
                          * with contigious address space from start to end
@@ -4348,6 +5516,7 @@ static virNetworkPtr vboxNetworkCreateXML(virConnectPtr conn, const char *xml) {
 
                         ret = virGetNetwork(conn, def->name, uuid);
 
+#if VBOX_API_VERSION == 2002
                         DEBUG("Real Network UUID: "
                               "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
                               (unsigned)vboxnet0IID->m0,    (unsigned)vboxnet0IID->m1,
@@ -4358,6 +5527,11 @@ static virNetworkPtr vboxNetworkCreateXML(virConnectPtr conn, const char *xml) {
                               (unsigned)vboxnet0IID->m3[7]);
 
                         data->pFuncs->pfnComUnallocMem(vboxnet0IID);
+#else
+                        DEBUG("Real Network UUID: %s", vboxnet0IIDUtf8);
+                        data->pFuncs->pfnUtf8Free(vboxnet0IIDUtf8);
+                        data->pFuncs->pfnUtf16Free(vboxnet0IIDUtf16);
+#endif
                         data->pFuncs->pfnUtf16Free(networkNameUtf16);
                     }
 
@@ -4371,7 +5545,9 @@ static virNetworkPtr vboxNetworkCreateXML(virConnectPtr conn, const char *xml) {
     }
 
 cleanup:
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#endif
     VIR_FREE(networkNameUtf8);
     virNetworkDefFree(def);
     return ret;
@@ -4381,7 +5557,11 @@ static virNetworkPtr vboxNetworkDefineXML(virConnectPtr conn, const char *xml) {
     vboxGlobalData *data  = conn->privateData;
     virNetworkDefPtr def  = NULL;
     virNetworkPtr ret     = NULL;
-    nsID *iid             = NULL;
+#if VBOX_API_VERSION == 2002
+    nsID  *iid           = NULL;
+#else
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     char *networkNameUtf8 = NULL;
 
     /* vboxNetworkDefineXML() is not exactly "network definition"
@@ -4391,12 +5571,13 @@ static virNetworkPtr vboxNetworkDefineXML(virConnectPtr conn, const char *xml) {
     if ((def = virNetworkDefParseString(conn, xml)) == NULL)
         goto cleanup;
 
-    if (VIR_ALLOC(iid) < 0) {
+    if (virAsprintf(&networkNameUtf8, "HostInterfaceNetworking-%s", def->name) < 0) {
         virReportOOMError(conn);
         goto cleanup;
     }
 
-    if (virAsprintf(&networkNameUtf8, "HostInterfaceNetworking-%s", def->name) < 0) {
+#if VBOX_API_VERSION == 2002
+    if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(conn);
         goto cleanup;
     }
@@ -4412,6 +5593,10 @@ static virNetworkPtr vboxNetworkDefineXML(virConnectPtr conn, const char *xml) {
           (unsigned)iid->m3[3], (unsigned)iid->m3[4],
           (unsigned)iid->m3[5], (unsigned)iid->m3[6],
           (unsigned)iid->m3[7]);
+#else
+    virUUIDFormat(def->uuid, iidUtf8);
+    DEBUG("Network UUID: %s", iidUtf8);
+#endif
 
     if ((data->vboxObj) && (def->forwardType == VIR_NETWORK_FORWARD_NONE)) {
         /* VirtualBox version 2.2.* has only one "hostonly"
@@ -4436,14 +5621,21 @@ static virNetworkPtr vboxNetworkDefineXML(virConnectPtr conn, const char *xml) {
 
                     if (interfaceType == HostNetworkInterfaceType_HostOnly) {
                         unsigned char uuid[VIR_UUID_BUFLEN];
-                        nsID *vboxnet0IID           = NULL;
                         PRUnichar *networkNameUtf16 = NULL;
-
-                        data->pFuncs->pfnUtf8ToUtf16(networkNameUtf8 , &networkNameUtf16);
+#if VBOX_API_VERSION == 2002
+                        nsID *vboxnet0IID           = NULL;
 
                         networkInterface->vtbl->GetId(networkInterface, &vboxnet0IID);
-
                         nsIDtoChar(uuid, vboxnet0IID);
+#else
+                        PRUnichar *vboxnet0IIDUtf16 = NULL;
+                        char      *vboxnet0IIDUtf8  = NULL;
+
+                        networkInterface->vtbl->GetId(networkInterface, &vboxnet0IIDUtf16);
+                        data->pFuncs->pfnUtf16ToUtf8(vboxnet0IIDUtf16, &vboxnet0IIDUtf8);
+                        virUUIDParse(vboxnet0IIDUtf8, uuid);
+#endif
+                        data->pFuncs->pfnUtf8ToUtf16(networkNameUtf8 , &networkNameUtf16);
 
                         /* Currently support only one dhcp server per network
                          * with contigious address space from start to end
@@ -4493,6 +5685,7 @@ static virNetworkPtr vboxNetworkDefineXML(virConnectPtr conn, const char *xml) {
 
                         ret = virGetNetwork(conn, def->name, uuid);
 
+#if VBOX_API_VERSION == 2002
                         DEBUG("Real Network UUID: "
                               "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
                               (unsigned)vboxnet0IID->m0,    (unsigned)vboxnet0IID->m1,
@@ -4503,6 +5696,11 @@ static virNetworkPtr vboxNetworkDefineXML(virConnectPtr conn, const char *xml) {
                               (unsigned)vboxnet0IID->m3[7]);
 
                         data->pFuncs->pfnComUnallocMem(vboxnet0IID);
+#else
+                        DEBUG("Real Network UUID: %s", vboxnet0IIDUtf8);
+                        data->pFuncs->pfnUtf8Free(vboxnet0IIDUtf8);
+                        data->pFuncs->pfnUtf16Free(vboxnet0IIDUtf16);
+#endif
                         data->pFuncs->pfnUtf16Free(networkNameUtf16);
                     }
 
@@ -4516,7 +5714,9 @@ static virNetworkPtr vboxNetworkDefineXML(virConnectPtr conn, const char *xml) {
     }
 
 cleanup:
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#endif
     VIR_FREE(networkNameUtf8);
     virNetworkDefFree(def);
     return ret;
@@ -4774,15 +5974,23 @@ static char *vboxNetworkDumpXML(virNetworkPtr network, int flags ATTRIBUTE_UNUSE
                 if (interfaceType == HostNetworkInterfaceType_HostOnly) {
                     def->name = strdup(network->name);
                     if (def->name != NULL) {
-                        nsID *vboxnet0IID           = NULL;
                         PRUnichar *networkNameUtf16 = NULL;
                         IDHCPServer *dhcpServer     = NULL;
-
-                        data->pFuncs->pfnUtf8ToUtf16(networkNameUtf8 , &networkNameUtf16);
+#if VBOX_API_VERSION == 2002
+                        nsID *vboxnet0IID           = NULL;
 
                         networkInterface->vtbl->GetId(networkInterface, &vboxnet0IID);
-
                         nsIDtoChar(def->uuid, vboxnet0IID);
+#else
+                        PRUnichar *vboxnet0IIDUtf16 = NULL;
+                        char      *vboxnet0IIDUtf8  = NULL;
+
+                        networkInterface->vtbl->GetId(networkInterface, &vboxnet0IIDUtf16);
+                        data->pFuncs->pfnUtf16ToUtf8(vboxnet0IIDUtf16, &vboxnet0IIDUtf8);
+                        virUUIDParse(vboxnet0IIDUtf8, def->uuid);
+#endif
+
+                        data->pFuncs->pfnUtf8ToUtf16(networkNameUtf8 , &networkNameUtf16);
 
                         def->forwardType = VIR_NETWORK_FORWARD_NONE;
 
